diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
index 58749dd1f..8954c1e4a 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
@@ -6,18 +6,17 @@ import java.io.InputStream;
 
 import javax.imageio.ImageIO;
 
-import org.lwjgl.opengl.GL11;
-
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.texture.BufferedTexture;
 
 public class TexturePackDefault extends TexturePack
 {
-    private int texturePackThumbnailTexture;
+    private BufferedTexture texturePackThumbnailTexture;
     private BufferedImage texturePackThumbnail;
 
     public TexturePackDefault()
     {
-        texturePackThumbnailTexture = -1;
+        texturePackThumbnailTexture = null;
         fileName = "Default";
         manifest = new Manifest(null, TexturePackDefault.class.getResourceAsStream("/manifest.json"));
         try
@@ -33,18 +32,18 @@ public class TexturePackDefault extends TexturePack
     @Override
     public void disposeOfTexturePack(Minecraft minecraft)
     {
-        if(texturePackThumbnail != null)
-        {
-            minecraft.renderEngine.deleteTexture(texturePackThumbnailTexture);
+        if(texturePackThumbnail != null) {
+            texturePackThumbnailTexture.delete();
+            texturePackThumbnailTexture = null;
         }
     }
 
     @Override
     public void bindThumbnailTexture(Minecraft minecraft)
     {
-        if(texturePackThumbnail != null && texturePackThumbnailTexture < 0)
+        if(texturePackThumbnail != null && texturePackThumbnailTexture == null)
         {
-            texturePackThumbnailTexture = minecraft.renderEngine.allocateAndSetupTexture(texturePackThumbnail);
+            texturePackThumbnailTexture = minecraft.renderEngine.loadBufferedTexture(texturePackThumbnail);
         }
         if(texturePackThumbnail != null)
         {
@@ -52,7 +51,7 @@ public class TexturePackDefault extends TexturePack
         }
         else
         {
-            GL11.glBindTexture(GL11.GL_TEXTURE_2D, minecraft.renderEngine.getTexture("/assets/minecraft/textures/gui/unknown_pack.png"));
+            minecraft.renderEngine.loadTexture("/assets/minecraft/textures/gui/unknown_pack.png").bind();
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index 0cbc89bf7..3ad526b0c 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -2,6 +2,8 @@ package net.minecraft.client.render.texturepack;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FontRenderer;
+import net.minecraft.core.Global;
+import org.jetbrains.annotations.Nullable;
 
 import java.io.File;
 import java.io.IOException;
@@ -86,7 +88,7 @@ public class TexturePackList
 		mc.fontRenderer = new FontRenderer(mc, mc.gameSettings, "/font/default.png", mc.renderEngine);
 		mc.renderGlobal.loadRenderers();
 		mc.currentScreen.refreshFontRenderer();
-		mc.renderEngine.updateDynamicTextures();
+		mc.renderEngine.updateDynamicTextures(false);
 	}
 
 	public boolean updateAvailableTexturePacks() {
@@ -98,18 +100,19 @@ public class TexturePackList
 			File[] filesInDir = texturePackDir.listFiles();
 			
 			if(filesInDir != null) {
-//				 remove this before releasing any live builds, this is explicitly so I can refresh the resources ingame without recompiling
-//				File[] tempList = new File[filesInDir.length + 1];
-//				for (int i = 0; i < tempList.length; i++) {
-//					if (i < tempList.length - 1){
-//						tempList[i] = filesInDir[i];
-//					} else {
-//						File local = new File("./src/main/resources");
-//						System.out.println(local.getAbsoluteFile());
-//						tempList[i] = local;
-//					}
-//				}
-//				filesInDir = tempList;
+				if (Global.BUILD_CHANNEL.isUnstableBuild()) { // Load project resources as an available texture pack
+					File[] tempList = new File[filesInDir.length + 1];
+					for (int i = 0; i < tempList.length; i++) {
+						if (i < tempList.length - 1){
+							tempList[i] = filesInDir[i];
+						} else {
+							File local = new File("./src/main/resources");
+							System.out.println(local.getAbsoluteFile());
+							tempList[i] = local;
+						}
+					}
+					filesInDir = tempList;
+				}
 
 				for(File file : filesInDir) {
 					if(!isTexturePack(file)) {
@@ -208,7 +211,7 @@ public class TexturePackList
 		return selectedPacks.get(selectedPacks.size()-1);
 	}
 	
-	public TexturePack getHighestPriorityTexturePackWithFile(String path) {
+	public @Nullable TexturePack getHighestPriorityTexturePackWithFile(String path) {
 		for(int i = selectedPacks.size() - 1; i >= 0; i--) {
 			TexturePack texturePack = selectedPacks.get(i);
 			if(texturePack.hasFile(path)) {
diff --git a/src/main/java/net/minecraft/client/render/window/GameWindowLWJGL2.java b/src/main/java/net/minecraft/client/render/window/GameWindowLWJGL2.java
index de85a957e..778539a67 100644
--- a/src/main/java/net/minecraft/client/render/window/GameWindowLWJGL2.java
+++ b/src/main/java/net/minecraft/client/render/window/GameWindowLWJGL2.java
@@ -57,7 +57,7 @@ public class GameWindowLWJGL2 implements GameWindow {
                 Thread.sleep(1000L);
             }
             catch(InterruptedException ignored) { }
-            Display.create();
+            Display.create(new PixelFormat());
         }
 	}
 
diff --git a/src/main/java/net/minecraft/client/sound/CodecMus.java b/src/main/java/net/minecraft/client/sound/CodecMus.java
index 00402653e..66b9cd587 100644
--- a/src/main/java/net/minecraft/client/sound/CodecMus.java
+++ b/src/main/java/net/minecraft/client/sound/CodecMus.java
@@ -2,24 +2,70 @@ package net.minecraft.client.sound;
 
 import java.io.IOException;
 import java.io.InputStream;
+import java.net.URL;
 
+import org.jetbrains.annotations.NotNull;
 import paulscode.sound.codecs.CodecJOrbis;
 
 // Referenced classes of package net.minecraft.src:
-//            MusInputStream
+//            DecoderInputStream
 
 public class CodecMus extends CodecJOrbis {
 
-    public CodecMus() {
-    }
-
     @Override
 	protected InputStream openInputStream() {
         try {
-            return new MusInputStream(this, url, urlConnection.getInputStream());
+            return new DecoderInputStream(url, urlConnection.getInputStream());
         } catch (IOException e) {
             e.printStackTrace();
             return null;
         }
     }
+    private static class DecoderInputStream extends InputStream
+    {
+
+        private int hash;
+        private final InputStream inputStream;
+        byte[] buffer;
+
+        public DecoderInputStream(URL url, InputStream inputstream)
+        {
+            buffer = new byte[1];
+            inputStream = inputstream;
+            String s = url.getPath();
+            s = s.substring(s.lastIndexOf("/") + 1);
+            hash = s.hashCode();
+        }
+
+        @Override
+        public int read()
+        {
+            int i = read(buffer, 0, 1);
+            if(i < 0)
+            {
+                return i;
+            } else
+            {
+                return buffer[0];
+            }
+        }
+
+        @Override
+        public int read(byte abyte0[], int i, int j)
+        {
+            try {
+                j = inputStream.read(abyte0, i, j);
+            } catch (IOException e) {
+                e.printStackTrace();
+                return 0;
+            }
+            for(int k = 0; k < j; k++)
+            {
+                byte byte0 = abyte0[i + k] ^= hash >> 8;
+                hash = hash * 0x1dba038f + 0x14ee3 * byte0;
+            }
+
+            return j;
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/client/sound/SoundEngine.java b/src/main/java/net/minecraft/client/sound/SoundEngine.java
new file mode 100644
index 000000000..7278b5158
--- /dev/null
+++ b/src/main/java/net/minecraft/client/sound/SoundEngine.java
@@ -0,0 +1,314 @@
+package net.minecraft.client.sound;
+
+import java.io.File;
+import java.io.IOException;
+import java.util.Random;
+
+import net.betterthanadventure.sound.LibraryLWJGL3OpenAL;
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.client.option.GameSettings;
+import paulscode.sound.SoundSystem;
+import paulscode.sound.SoundSystemConfig;
+import paulscode.sound.codecs.CodecJOrbis;
+import paulscode.sound.codecs.CodecWav;
+import paulscode.sound.libraries.LibraryLWJGLOpenAL;
+
+// Referenced classes of package net.minecraft.src:
+//            SoundRepository, GameSettings, CodecMus, LocalPlayer,
+//            MathHelper, World, SoundEntry, Mob
+
+public class SoundEngine
+{
+	private static final int SOUND_DISTANCE = 16;
+	public static final int MUSIC_INTERVAL = 6000;
+	private static SoundSystem soundSystem;
+	private static boolean loaded = false;
+
+	public final SoundRepository soundRepo;
+	public final SoundRepository streamingRepo;
+	public final SoundRepository musicRepo;
+	public final SoundRepository caveRepo;
+	private int idCounter;
+	private GameSettings options;
+	private final Random random;
+	private Minecraft mc;
+	public int ticksBeforeMusic;
+	private boolean muted = false;
+
+	private static void loadModAudio(final String directory, final SoundRepository targetRepo)
+	{
+		final File file = Minecraft.getAppDir(directory);
+		try {
+			walkFolder(file, file, targetRepo);
+		} catch (final IOException ioexception) {
+			ioexception.printStackTrace();
+		}
+	}
+
+	private static void loadDevAudio(final String directory, final SoundRepository targetRepo)
+	{
+		final File file = new File(directory);
+		try {
+			walkFolder(file, file, targetRepo);
+		} catch (final IOException ioexception) {
+			ioexception.printStackTrace();
+		}
+	}
+
+    private static void walkFolder(final File baseFile, final File currentFile, final SoundRepository targetRepo) throws IOException {
+        if (currentFile.exists() || currentFile.mkdirs()) {
+            final File[] filesInCurrentDir = currentFile.listFiles();
+            if (filesInCurrentDir != null) {
+                for (File file : filesInCurrentDir) {
+                    if (!file.getName().startsWith(".")) {
+                        if (file.isDirectory()) {
+                            walkFolder(baseFile, file, targetRepo);
+                        } else if (file.isFile()) {
+                            final String name = file.getPath().substring(baseFile.getPath().length() + 1).replace('\\', '/');
+                            targetRepo.addSound(name, file);
+                        }
+                    }
+                }
+
+            }
+        }
+    }
+
+	public SoundEngine() {
+        soundRepo = new SoundRepository();
+        streamingRepo = new SoundRepository();
+        musicRepo = new SoundRepository();
+        caveRepo = new SoundRepository();
+        idCounter = 0;
+        random = new Random();
+        ticksBeforeMusic = random.nextInt(MUSIC_INTERVAL);
+    }
+
+    public void addMusic(final String name, final File file) {
+        musicRepo.addSound(name, file);
+    }
+
+    public void addSound(final String name, final File file) {
+        soundRepo.addSound(name, file);
+    }
+
+    public void addStreaming(final String name, final File file) {
+        streamingRepo.addSound(name, file);
+    }
+
+	public void destroy() {
+		if (loaded) {
+			soundSystem.cleanup();
+		}
+	}
+	
+	public void setMuted(boolean muted)
+	{
+		if (soundSystem == null) return;
+		this.muted = muted;
+		if (this.muted) {
+			soundSystem.setVolume("BgMusic", 0.0f);
+		} else {
+			soundSystem.setVolume("BgMusic", SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, options));
+		}
+	}
+
+	public void updateListener(final Mob player, final float partialTick)
+	{
+		if (!loaded || muted || soundSystem == null || !SoundCategoryHelper.isAnyEnabled(options)) {
+			return;
+		}
+		if (player != null) {
+			final float yRot = MathHelper.lerp(player.yRotO, player.yRot, partialTick);
+			final double playerX = MathHelper.lerp(player.xo, player.x, partialTick);
+			final double playerY = MathHelper.lerp(player.yo, player.y, partialTick);
+			final double playerZ = MathHelper.lerp(player.zo, player.z, partialTick);
+			final float yCos = MathHelper.cos(MathHelper.toRadians(-yRot - 180));
+			final float ySin = MathHelper.sin(MathHelper.toRadians(-yRot - 180));
+			final float xa = -ySin;
+			final float ya = 0.0F;
+			final float za = -yCos;
+			final float xa2 = 0.0F;
+			final float ya2 = 1.0F;
+			final float za2 = 0.0F;
+			soundSystem.setListenerPosition((float) playerX, (float) playerY, (float) playerZ);
+			soundSystem.setListenerOrientation(xa, ya, za, xa2, ya2, za2);
+		}
+    }
+
+    public void init(final GameSettings gamesettings) {
+        streamingRepo.trimDigits = false;
+        options = gamesettings;
+        if (!loaded && (gamesettings != null && SoundCategoryHelper.isAnyEnabled(gamesettings))) {
+            loadLibrary();
+        }
+		loadDevAudio("devResources/sound", soundRepo);
+		loadDevAudio("devResources/streaming", streamingRepo);
+		loadDevAudio("devResources/music", musicRepo);
+		loadDevAudio("devResources/cavemusic", caveRepo);
+        loadModAudio("minecraft-bta/resources/mod/sound", soundRepo);
+        loadModAudio("minecraft-bta/resources/mod/streaming", streamingRepo);
+        loadModAudio("minecraft-bta/resources/mod/music", musicRepo);
+        loadModAudio("minecraft-bta/resources/mod/cavemusic", caveRepo);
+		mc = Minecraft.getMinecraft(this);
+    }
+
+    public void updateOptions() {
+        if (!loaded && SoundCategoryHelper.isAnyEnabled(options)) {
+            loadLibrary();
+        }
+        if (soundSystem != null && loaded) {
+            if (SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, options) == 0.0F) {
+                soundSystem.stop("BgMusic");
+            } else {
+                soundSystem.setVolume("BgMusic", SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, options));
+            }
+        }
+    }
+
+    public void tick() {
+        if (!loaded || soundSystem == null || SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, options) == 0.0F) {
+            return;
+        }
+
+        if (!soundSystem.playing("BgMusic") && !soundSystem.playing("streaming")) {
+            if (ticksBeforeMusic > 0) {
+                ticksBeforeMusic--;
+                return;
+            }
+            SoundEntry entry;
+            if (mc != null && mc.thePlayer != null && !mc.thePlayer.world.canBlockSeeTheSky(MathHelper.floor(mc.thePlayer.x), MathHelper.floor(mc.thePlayer.y), MathHelper.floor(mc.thePlayer.z))) {
+                entry = caveRepo.getAnyEntry();
+            } else {
+                entry = musicRepo.getAnyEntry();
+            }
+            if (entry != null) {
+                ticksBeforeMusic = random.nextInt(MUSIC_INTERVAL) + MUSIC_INTERVAL;
+                soundSystem.backgroundMusic("BgMusic", entry.url, entry.name, false);
+                soundSystem.setVolume("BgMusic", SoundCategoryHelper.getEffectiveVolume(SoundCategory.MUSIC, options));
+                soundSystem.play("BgMusic");
+            }
+        }
+    }
+
+	public void playSoundAt(final String soundPath, SoundCategory category, final float x, final float y, final float z, float volume, final float pitch)
+	{
+		if (!loaded || soundSystem == null || muted || !SoundCategoryHelper.isAnyEnabled(options))
+		{
+			return;
+		}
+		final SoundEntry soundEntry = soundRepo.getEntry(soundPath);
+		if (soundEntry != null && volume > 0.0F)
+		{
+			idCounter = (idCounter + 1) % 256;
+			final String soundIdName = "sound_" + idCounter;
+			float f5 = 16F;
+			if (volume > 1.0F)
+			{
+				f5 *= volume;
+			}
+			soundSystem.newSource(volume > 1.0F, soundIdName, soundEntry.url, soundEntry.name, false, x, y, z, 2, f5);
+			soundSystem.setPitch(soundIdName, pitch);
+			if (volume > 1.0F)
+			{
+				volume = 1.0F;
+			}
+			soundSystem.setVolume(soundIdName, volume * SoundCategoryHelper.getEffectiveVolume(category, options));
+			soundSystem.play(soundIdName);
+		}
+	}
+
+	public void playSound(final String soundPath, SoundCategory category, float volume, final float pitch)
+	{
+		if (!loaded || soundSystem == null || muted || !SoundCategoryHelper.isAnyEnabled(options))
+		{
+			return;
+		}
+		final SoundEntry soundEntry = soundRepo.getEntry(soundPath);
+		idCounter = (idCounter + 1) % 256;
+		final String soundName = "sound_" + idCounter;
+		playSoundEntry(soundEntry, soundName, category, volume, pitch);
+	}
+	public void playSoundEntry(SoundEntry entry, String soundSourceID, SoundCategory category, float volume, final float pitch) {
+		if (entry != null) {
+			soundSystem.newSource(false, soundSourceID, entry.url, entry.name, false, 0.0F, 0.0F, 0.0F, 0, 0.0F);
+			if (volume > 1.0F)
+			{
+				volume = 1.0F;
+			}
+			volume *= 0.25F;
+			soundSystem.setPitch(soundSourceID, pitch);
+			soundSystem.setVolume(soundSourceID, volume * SoundCategoryHelper.getEffectiveVolume(category, options));
+			soundSystem.play(soundSourceID);
+		}
+	}
+	public void playSoundId(final String soundPath, SoundCategory category, float volume, final float pitch, String soundID){
+		if (!loaded || soundSystem == null || muted || !SoundCategoryHelper.isAnyEnabled(options))
+		{
+			return;
+		}
+		final SoundEntry soundEntry = soundRepo.getEntry(soundPath);
+		playSoundEntry(soundEntry, soundID, category, volume, pitch);
+	}
+
+	public void playStreaming(final String soundPath, final float x, final float y, final float z, final float volume, final float pitch)
+	{
+		if (!loaded || soundSystem == null || muted || !SoundCategoryHelper.isAnyEnabled(options))
+		{
+			return;
+		}
+		final String streaming = "streaming";
+		if (soundSystem.playing("streaming"))
+		{
+			soundSystem.stop("streaming");
+		}
+		if (soundPath == null)
+		{
+			return;
+		}
+		final SoundEntry soundEntry = streamingRepo.getEntry(soundPath);
+		if (soundEntry != null && volume > 0.0F)
+		{
+			if (soundSystem.playing("BgMusic"))
+			{
+				soundSystem.stop("BgMusic");
+			}
+			final float streamingVolume = 16F;
+			soundSystem.newStreamingSource(true, streaming, soundEntry.url, soundEntry.name, false, x, y, z, 2, streamingVolume * 4F);
+			soundSystem.setVolume(streaming, 0.5F * options.masterVolume.value);
+			soundSystem.play(streaming);
+		}
+	}
+
+    private void loadLibrary() {
+        try {
+			float[] volumeStore = new float[SoundCategory.values().length];
+			for (int i = 0; i < SoundCategory.values().length; i++)
+			{
+				volumeStore[i] = SoundCategoryHelper.getVolume(SoundCategory.values()[i], options);
+			}
+            options.saveOptions();
+            SoundSystemConfig.addLibrary(LibraryLWJGL3OpenAL.class);
+            SoundSystemConfig.setCodec("ogg", CodecJOrbis.class);
+            SoundSystemConfig.setCodec("mus", CodecMus.class);
+            SoundSystemConfig.setCodec("wav", CodecWav.class);
+            soundSystem = new SoundSystem();
+			for (int i = 0; i < SoundCategory.values().length; i++)
+			{
+				SoundCategoryHelper.setVolume(SoundCategory.values()[i], options, volumeStore[i]);
+			}
+			options.saveOptions();
+        } catch (final Throwable throwable) {
+            throwable.printStackTrace();
+            System.err.println("error linking with the LibraryJavaSound plug-in");
+        }
+        loaded = true;
+    }
+	public static SoundSystem getSoundSystem(){
+		return soundSystem;
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/sound/SoundEntry.java b/src/main/java/net/minecraft/client/sound/SoundEntry.java
new file mode 100644
index 000000000..8aa1b1c94
--- /dev/null
+++ b/src/main/java/net/minecraft/client/sound/SoundEntry.java
@@ -0,0 +1,17 @@
+package net.minecraft.client.sound;
+
+import java.net.URL;
+
+public class SoundEntry
+{
+
+    public String soundID;
+    public String name;
+    public URL url;
+
+    public SoundEntry(String soundID, String name, URL url) {
+        this.soundID = soundID;
+        this.name = name;
+        this.url = url;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/sound/SoundRepository.java b/src/main/java/net/minecraft/client/sound/SoundRepository.java
new file mode 100644
index 000000000..46f49d1ff
--- /dev/null
+++ b/src/main/java/net/minecraft/client/sound/SoundRepository.java
@@ -0,0 +1,83 @@
+package net.minecraft.client.sound;
+
+import java.io.File;
+import java.net.MalformedURLException;
+import java.util.*;
+
+// Referenced classes of package net.minecraft.src:
+//            SoundEntry
+
+public class SoundRepository
+{
+    private final Random random;
+    private final Map<String, List<SoundEntry>> urls;
+    private final List<SoundEntry> allEntries;
+    public int entryCount;
+    public boolean trimDigits;
+
+
+    public SoundRepository()
+    {
+        random = new Random();
+        urls = new HashMap<>();
+        allEntries = new ArrayList<>();
+        entryCount = 0;
+        trimDigits = true;
+    }
+
+    public SoundEntry addSound(String fileName, File file)
+    {
+        String id = fileName;
+        try
+        {
+            id = id.substring(0, id.indexOf("."));
+            if(trimDigits)
+            {
+                while (Character.isDigit(id.charAt(id.length() - 1))) {
+                    id = id.substring(0, id.length() - 1);
+                }
+            }
+            id = id.replaceAll("/", ".");
+            if(!urls.containsKey(id))
+            {
+                urls.put(id, new ArrayList<>());
+            }
+            SoundEntry soundEntry = new SoundEntry(id, fileName, file.toURI().toURL());
+            urls.get(id).add(soundEntry);
+            allEntries.add(soundEntry);
+            entryCount++;
+            return soundEntry;
+        }
+        catch(MalformedURLException e)
+        {
+        	throw new RuntimeException("Adding Sound: " + id + " ("+file.getAbsolutePath()+")", e);
+        }
+    }
+
+    public SoundEntry getEntry(String name)
+    {
+        List<SoundEntry> values = urls.get(name);
+        if(values == null)
+        {
+            return null;
+        } else
+        {
+            return values.get(random.nextInt(values.size()));
+        }
+    }
+
+    public SoundEntry getAnyEntry()
+    {
+        if(allEntries.isEmpty())
+        {
+            return null;
+        } else
+        {
+            return allEntries.get(random.nextInt(allEntries.size()));
+        }
+    }
+
+    public List<SoundEntry> getAllEntries() {
+        return allEntries;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/util/helper/Colors.java b/src/main/java/net/minecraft/client/util/helper/Colors.java
index 7260ea416..39a9cf811 100644
--- a/src/main/java/net/minecraft/client/util/helper/Colors.java
+++ b/src/main/java/net/minecraft/client/util/helper/Colors.java
@@ -21,12 +21,12 @@ public abstract class Colors {
 	public static final Color[] allRedstoneColors = new Color[16];
 	
 	public static void loadColors() {
-		fillColorArray("/misc/colors_chat.png", allChatColors);
-		fillColorArray("/misc/colors_planks.png", allPlankColors);
-		fillColorArray("/misc/colors_signs.png", allSignColors);
-		fillColorArray("/misc/colors_lamps.png", allLampColors);
-		fillColorArray("/misc/colors_flag.png", allFlagColors);
-		fillColorArray("/misc/colors_redstone.png", allRedstoneColors);
+		fillColorArray("/assets/minecraft/textures/misc/colors_chat.png", allChatColors);
+		fillColorArray("/assets/minecraft/textures/misc/colors_planks.png", allPlankColors);
+		fillColorArray("/assets/minecraft/textures/misc/colors_signs.png", allSignColors);
+		fillColorArray("/assets/minecraft/textures/misc/colors_lamps.png", allLampColors);
+		fillColorArray("/assets/minecraft/textures/misc/colors_flag.png", allFlagColors);
+		fillColorArray("/assets/minecraft/textures/misc/colors_redstone.png", allRedstoneColors);
 	}
 	
 	public static void fillColorArray(String path, Color[] colors) {
diff --git a/src/main/java/net/minecraft/client/util/helper/GuiItemDragHandler.java b/src/main/java/net/minecraft/client/util/helper/GuiItemDragHandler.java
index de6936659..4f2d26f4c 100644
--- a/src/main/java/net/minecraft/client/util/helper/GuiItemDragHandler.java
+++ b/src/main/java/net/minecraft/client/util/helper/GuiItemDragHandler.java
@@ -95,8 +95,8 @@ public class GuiItemDragHandler extends Gui {
 			return;
 		}
 		
-		if(slot.canPutStackInSlot(draggingItemStack) && slot.enableDragAndPickup()) {
-			if(slot.getStack() == null || slot.getStack().canStackWith(draggingItemStack)) {
+		if(slot.mayPlace(draggingItemStack) && slot.enableDragAndPickup()) {
+			if(slot.getItem() == null || slot.getItem().canStackWith(draggingItemStack)) {
 				if(!draggedSlots.contains(slot)) {
 					draggedSlots.add(slot);
 				}
@@ -108,13 +108,13 @@ public class GuiItemDragHandler extends Gui {
 		if(slot == null) throw new NullPointerException("Slot is null");
 		if(draggingItemStack == null) throw new NullPointerException("Stack is null!");
 
-		ItemStack stack = slot.getStack();
+		ItemStack stack = slot.getItem();
 		
 		glDisable(GL_TEXTURE_2D);
 		glEnable(GL_BLEND);
 		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 		
-		drawRectWidthHeight(renderOffsetX + slot.xDisplayPosition, renderOffsetY + slot.yDisplayPosition, 16, 16, 0x80ffffff);
+		drawRectWidthHeight(renderOffsetX + slot.x, renderOffsetY + slot.y, 16, 16, 0x80ffffff);
 		
 		glDisable(GL_BLEND);
 		glEnable(GL_TEXTURE_2D);
@@ -123,7 +123,7 @@ public class GuiItemDragHandler extends Gui {
 		if(stack != null) {
 			renderItemStack.stackSize = Math.min(renderItemStack.getMaxStackSize(), renderItemStack.stackSize + stack.stackSize);
 		}
-		guiRenderItem.render(renderItemStack, slot.xDisplayPosition, slot.yDisplayPosition);
+		guiRenderItem.render(renderItemStack, slot.x, slot.y);
 	}
 	
 	public void mouseEvent(final int x, final int y, int button, boolean pressed) {
@@ -154,7 +154,7 @@ public class GuiItemDragHandler extends Gui {
 	}
 	
 	public void click(InventoryAction action, int[] args) {
-		mc.playerController.handleInventoryMouseClick(container.inventorySlots.windowId, action, args, mc.thePlayer);
+		mc.playerController.handleInventoryMouseClick(container.inventorySlots.containerId, action, args, mc.thePlayer);
 	}
 	
 	private void mousePressed(final int x, final int y, final Slot slot, int button) {
@@ -252,10 +252,10 @@ public class GuiItemDragHandler extends Gui {
 		
 		int[] slots = new int[draggedSlots.size()];
 		for(int i=0; i < slots.length; i++) {
-			slots[i] = draggedSlots.get(i).id;
+			slots[i] = draggedSlots.get(i).index;
 		}
 		
-		mc.playerController.handleInventoryMouseClick(container.inventorySlots.windowId, action, slots, mc.thePlayer);
+		mc.playerController.handleInventoryMouseClick(container.inventorySlots.containerId, action, slots, mc.thePlayer);
 		
 	}
 	
@@ -264,7 +264,7 @@ public class GuiItemDragHandler extends Gui {
 			return;
 		}
 		
-		mc.playerController.handleInventoryMouseClick(container.inventorySlots.windowId, InventoryAction.PICKUP_SIMILAR, null, mc.thePlayer);
+		mc.playerController.handleInventoryMouseClick(container.inventorySlots.containerId, InventoryAction.PICKUP_SIMILAR, null, mc.thePlayer);
 	}
 	
 	public boolean isDragging() {
diff --git a/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java b/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
index e3a18994c..e51b1a1f6 100644
--- a/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
+++ b/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
@@ -14,7 +14,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FallbackRenderer;
 import net.minecraft.client.render.Framebuffer;
 import net.minecraft.client.render.Renderer;
-import net.minecraft.client.render.Texture;
+import net.minecraft.client.render.texture.Texture;
 import net.minecraft.core.Global;
 import net.minecraft.core.util.helper.Buffer;
 
